<?php
/*      
        NOTE THAT YOU HAVE NO RIGHTS TO MODIFY THE SOURCE CODE!
        READ THE LICENSE AND THE MANUAL FOR MORE INFORMATIONS.

        */



/**********************************************************************
	declaration of functions 
**********************************************************************/

//function to create logfiles
function CreateNewEmptyFile ($FileToCreate)
{
	
	//Create file with 0 bytes
	if(@!fopen ($FileToCreate, "w") OR @!chmod ($FileToCreate, 0666))
	{
		//failure text
		
		//get the user of the running php script
		$CurrentUser 	= @get_current_user ();
		if (!$CurrentUser){ $CurrentUser = "unknown"; }
		
		$Out =<<<END
phpMySearch is running under your system as the user <i>$CurrentUser</i>.</br>
But the user <i>$CurrentUser</i> have no rights to write the file <i>$FileToCreate</i> to your system.</br><br>
You must set the filepermissions to writeable that 
phpMySearch is able to write this file.<br>
You can do this e.g. under UNIX-systems with:</br>
<i>CHMOD 666</i> or <i>CHMOD UGO+RW</i></br>
You can do this e.g. with your FTP client.<br><br>
<b>Installation aborted!</b><br>
END;
		
		echo $Out;
		exit();
		
	}

}

//control if a file is readable
function FileIsReadable ($FileToCheck)
{
	
	if(@!fopen ($FileToCheck, "r"))
	{
		
		//get the file owner
		$FileOwner 	= @fileowner ($FileToCheck);
		if (!$FileOwner){ $FileOwner = "unknown"; }
		
		//get the user of the running php script
		$CurrentUser 	= get_current_user ();
		if (!$CurrentUser){ $CurrentUser = "unknown"; }
		
		$Out =<<<END
phpMySearch is running under your system as the user <i>$CurrentUser</i>.</br>
The owner of the file <i>$FileToCheck</i> is <i>$FileOwner</i>.</br>
The user <i>$CurrentUser</i> have no rights to read the file <i>$FileToCheck</i> or the file does not exists on your system.</br><br>
You must set the filepermissions of <i>$FileToCheck</i> to readable.<br>
You can do this e.g. under UNIX-systems with:</br>
<i>CHMOD 666</i> or <i>CHMOD UGO+RW</i></br>
You can do this e.g. with your FTP client.<br><br>
<b>Installation aborted!</b><br>
END;
		
		echo $Out;
		exit();
		
	}

}

//control if a directory is readable
function DirIsReadable ($DirToCheck)
{
	
	if(@!is_readable($DirToCheck))
	{
		
		//get the file owner
		$FileOwner 	= @fileowner ($DirToCheck);
		if (!$FileOwner){ $FileOwner = "unknown"; }
		
		//get the user of the running php script
		$CurrentUser 	= get_current_user ();
		if (!$CurrentUser){ $CurrentUser = "unknown"; }
		
		$Out =<<<END
phpMySearch is running under your system as the user <i>$CurrentUser</i>.</br>
The owner of the directory <i>$DirToCheck</i> is <i>$FileOwner</i>.</br>
The user <i>$CurrentUser</i> have no rights to read the directory <i>$DirToCheck</i> or the directory does not exists on your system.</br><br>
You must set the filepermissions of <i>$DirToCheck</i> to readable.<br>
You can do this e.g. under UNIX-systems with:</br>
<i>CHMOD 666</i> or <i>CHMOD UGO+RW</i></br>
You can do this e.g. with your FTP client.<br><br>
<b>Installation aborted!</b><br>
END;
		
		echo $Out;
		exit();
		
	}

}



/**********************************************************************
	define variables
**********************************************************************/

//set directory path
$a = explode ("install.php", $HTTP_SERVER_VARS["SCRIPT_FILENAME"]);
$Path = $a[0];

//set DataBaseSettings file name
$DataBaseSettings = $Path."Src/DataBaseSettings.inc.php";



/**********************************************************************
	aborts the installation if DataBaseSettings exists
**********************************************************************/

//check for DataBaseSettings
if (@fopen ($DataBaseSettings, "r")){
	echo <<<AUSGABE
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<font color="red"><b>ERROR</b></font>
		<p>If you want to reinstall phpMySearch you must delete the file:</p>
		<p><i>$DataBaseSettings</i></p>
		<p>manually e.g. with your FTP-Client.</p>
		<p>After that you are able to execute this installation again.</p>
		<p></p>
		<b>Installation aborted!</b><br>
	</body>

</html>
AUSGABE;

exit();

}



/**********************************************************************
	Aborts the installation
**********************************************************************/

//abort installation
if ($HTTP_POST_VARS["Step"]=="Abort"){
	header ("Location: http://phpMySearch.web4.hm");
	exit();
	
}

//not agree to license
if ($HTTP_POST_VARS["Step"]=="no"){
	header ("Location: http://phpMySearch.web4.hm");
	exit();

}


/**********************************************************************
	1st site
**********************************************************************/

//output the 1st page to browser
if (!$HTTP_POST_VARS["Step"]){
echo <<<AUSGABE
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<form name="FormName" action="install.php" method="POST">
			<div align="center">
				<b>This is the installationsscript for phpMySearch</b>
				<p>Please choose your language /</p>
				<p>Bitte waehlen Sie Ihre Sprache</p>
				<p><input type="submit" name="Step" value="English"><input type="submit" name="Step" value="Deutsch"></p>
			</div>
		</form>
	</body>

</html>
AUSGABE;

exit();

}

/**********************************************************************
	english license
**********************************************************************/

//output the license to browser
if ($HTTP_POST_VARS["Step"]=="English"){

	echo <<<AUSGABE
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
  <title></title>
  <meta http-equiv="content-type"
 content="text/html; charset=ISO-8859-1">
</head>
<body>
<h1>License Agreement </h1>
<br>
It is highly recommended that you read every point of this license agreement.
It contains informations on what you can do with this software and must not
do with this software. Many questions are answered in the body of this document,
please read it carefully. <br>
--------------------------------------------------------------------------------<br>
<br>
phpMySearch Software<br>
Final User License<br>
<br>
PRICING<br>
private and not-commercial use, non-profit
organisations and associations: <BR>
&middot; User (C-licence): EURO 0.00<br>
<BR>
other or commercial use: <BR>
&middot; Premium User (B-licence): EURO 19.95
<BR>
<br>
OPTIONAL SERVICES<br>
&middot; Permission to remove copyright in
the source code (A-licence): EURO 499.00<br>
<br>
<br>
LICENSE<br>
web4.hm permits you in this not exclusive license to use the software as far
as it scores all this license keeps.<br>
<br>
Note: phpMySearch is NO open source software product. The conditions specified
in this license must be followed. With acquisition of the A-license it is
permitted to you to amend the software i.e. that you must not remove the
copyright notices in the source code for example.<br>
<br>
Technical support and related services are available to those who follow
this Agreement at "http://www.phpmysearch.web4.hm". web4.hm reserves the
right to limit or refuse free technical support and related services in any
form for any reason. <br>
<br>
If you do not wish to be under the free support limitations, you must purchase
a priority support service agreement (Premium User i.e. B-license).<br>
<br>
<br>
SCOPE OF GRANT<br>
It is permitted:<br>
&middot; to use the Software on one or more of your own computers.<br>
&middot; to provide backup copies for archival purposes.<br>
&middot; to modify or expand the functions from phpMySearch, if you send
us the changed code.<br>
&middot; to adapt the software over the Templates optically.<br>
<br>
It is forbidden:<br>
&middot; to offer and/or distribute the software commercially in any form.<br>
&middot; to pass on and sell the software to other persons and/or install
the software on other persons computers if they do not have a valid B-license.<br>
&middot; to remove, modify and/or change any copyright notices and other
property notes, legends, symbols and inscriptions in the software without
a valid A-license.<br>
&middot; to remove, modify and/or change the copyright notices in the source
code.<br>
&middot; to publish parts and/or excerpts of phpMySearch in other projects
in any form.<br>
&middot; to distribute the software for free without permissions from web4.hm.<br>
<br>
DISCLAIMER OF WARRANTY<br>
The Software is provided on an "AS IS" basis, without warranty of any kind,
including without limitation the warranties of merchantability, fitness for
a particular purpose and non-infringement. The entire risk as to the quality
and performance of the Software is borne by you. Should the Software prove
defective, you and not web4.hm assume the entire cost of any service and
repair. In addition, the security mechanisms implemented by phpMySearch software
have inherent limitations, and you must determine that the Software sufficiently
meets your requirements. This disclaimer of warranty constitutes an essential
part of the agreement. <br>
<br>
TITLE<br>
Title, ownership rights, and intellectual rights in the software remain within
phpMySearch. The Software is protected by copyright laws and treaties. Title
and related rights in the content accessed through the Software is the property
of the applicable content owner and may be protected by applicable law. This
license does not give you rights at this contents.<br>
<br>
TERMINATION<br>
This Agreement will terminate automatically if you fail to comply with the
limitations described herein. On termination, you must destroy all copies
of the Software within 48 hours. web4.hm is allowed to forbid the usage of
this program or code-parts every time.<br>
<br>
MISCELLANEOUS<br>
A current copy of this Agreement will be available on the phpMySearch web
site. This product is not free for reselling.<br>
<br>
PROPRIETARY LABELS<br>
Authorisation to remove copyright notices can be obtained from phpMySearch
for a one time fee of EURO 499,-. This fee authorises you to remove the output
of copyright notices, but it gives you no authorisation neither to remove
any copyright notices in the script source header files, nor any other rights.<br>
<br>
<br>
CONTRACT PENALTY<br>
If you breach this licence, or use this software without following the terms
of use, you have to pay a contract penalty in amount of EURO 2000,-. The
Licence is according to German law in force. Place of jurisdiction is Hameln,
Germany.<br>
<br>
<br>
MANUFACTURER<br>
Webagentur web4.hm, http://www.web4.hm<br>
Tel: +49-5151-60 99 700 (Europe, Germany)<br>
Email: phpMySearch@web4.hm<br>
<br>
Donations to support continued development are appreciated. Donations are
not tax deductible.<br>
<br>

	<br><form name="FormName" action="install.php" method="POST">
			<p><input type="radio" value="3" name="Step">I agree to this terms<br>
				<input type="radio" value="no" name="Step" checked>I do not agree to this terms</p>
			<div align="left">
				<p><input type="submit" name="submitButtonName" value="Next"></p>
			</div>
		</form>
	</body>

</html>

AUSGABE;

exit();

}



/**********************************************************************
	deutsche Lizenz
**********************************************************************/

//output the license to browser
if ($HTTP_POST_VARS["Step"]=="Deutsch"){

	echo <<<AUSGABE
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
  <title></title>
  <meta http-equiv="content-type"
 content="text/html; charset=ISO-8859-1">
</head>
<body>
<h1>Endbenutzerlizenz </h1>
Wir raten Ihnen dringend, dass Sie alle Punkte dieser Lizenz lesen. Sie enth&auml;lt
Informationen, was Sie mit der Software machen d&uuml;rfen und was nicht.<br>
<br>
Dieses Dokument legt die Lizenzbedingungen sowie Gew&auml;hrleistungsausschl&uuml;sse
und Haftungsbeschr&auml;nkungen fest und ist eine rechtswirksame Vereinbarung
zwischen Ihnen und web4.hm, ("web4.hm") und zwar f&uuml;r die phpMySearch
Software (die "Software") und die zugeh&ouml;rige Dokumentation. Bevor Sie
die Software installieren oder verwenden, lesen Sie bitte sorgf&auml;ltig
die nachfolgenden Vertragspunkte.<br>
--------------------------------------------------------------------------------<br>
<br>
phpMySearch Software<br>
Endbenutzerlizenz<br>
<br>
<br>
<B>
Preise:</B><br>
private und nichtgewerbliche Nutzung, gemeinntzige
Organisationen und e.Vereine: <BR>
&middot; User (C-Lizenz): EURO 0.00<br>
<BR>
andere oder gewerbliche Nutzung: <BR>
&middot; Premium User (B-Lizenz): EURO 19.95
inkl. MwSt. <BR>
<br>
durch weitere Lizenzen erh&auml;ltlich (nicht in dieser enthalten):<br>
&middot; Copyrightinformationen entfernen
(A-Lizenz): EURO 499.00 inkl. MwSt.<br>
<br>
<br>
Lizenz<br>
web4.hm erlaubt Ihnen in dieser nicht exklusiven Lizenz, die Software zu
benutzen, soweit Sie alle Punkte dieser Lizenz einhalten.<br>
<br>
Wichtig: phpMySearch ist KEINE open source Software. Die Bedingungen dieser
Lizenz m&uuml;ssen Folge geleistet werden. Wir haben spezielle Lizenzen entwickelt,
die es Ihnen erm&ouml;glichen die Software abzu&auml;ndern, bzw. das Copyright
in der HTML Ausgabe zu entfernen, sp&auml;ter gibt es mehr Informationen
dazu.<br>
<br>
Technischen Support zu diesem Produkt gibt es auf der phpMySearch Webseite
(http://phpmysearch.web4.hm). web4.hm beh&auml;lt sich das Recht vor, ohne
Angabe von Gr&uuml;nden, kostenlose Supportunterst&uuml;tzung einzuschr&auml;nken
oder einzustellen.<br>
<br>
Falls Sie garantierten Support zu der Software ben&ouml;tigen, so haben Sie
die M&ouml;glichkeit sich als Premium User (B-Lizenz) registrieren zu lassen.
Schreiben Sie hierzu eine eMail an die unten angegebene Emailadresse.<br>
<br>
<br>
Benutzungsbedingungen:<br>
Sie d&uuml;rfen:<br>
&middot; die Software auf einem oder mehreren Computern einsetzten.<br>
&middot; die Software als Sicherungskopie auf Ihrem Rechner belassen, oder
auf transportable Datentr&auml;ger kopieren, wenn Sie alle Dokumentationen
und die Software unver&auml;ndert &uuml;bernehmen. <br>
&middot; die Softwarefunktionen ver&auml;ndern/erweitern, sofern Sie den
ge&auml;nderten Code an die unten stehende Emailadresse senden, das Copyright
der Software bleibt dabei unber&uuml;hrt.<br>
&middot; Die Software &uuml;ber die HTML Templates optisch anpassen.<br>
<br>
Sie d&uuml;rfen nicht:<br>
&middot; die Software gewerblich anbieten, oder vertreiben.<br>
&middot; die Software an Dritte weitergeben oder weiterver&auml;u&szlig;ern.<br>
&middot; die Software als Unternehmung anderen zur Installation anbieten,
ohne nicht zumindest eine B-Lizenz pro Endkunde zu erwerben, andere Punkte
dieser Lizenz bleiben unber&uuml;hrt.<br>
&middot; die Copyright- und andere Eigentumsvermerke, Legenden, Symbole und
Beschriftungen innerhalb der Software weder entfernen noch ver&auml;ndern,
wenn Sie nicht im Besitz einer A-Lizenz sind.<br>
&middot; die Copyrightvermerke in der HTML Ausgabe, sowie dem HTML Quelltext
entfernen, wenn Sie nicht im Besitz einer A-Lizenz sind.<br>
&middot; die Copyrighthinweise des Programmquellcodes ver&auml;ndern oder
entfernen.<br>
&middot; die Software direkt zum Download anbieten.<br>
&middot; Teile dieser Software, oder Ausz&uuml;ge aus dem Quellcode ver&ouml;ffentlichen
und/oder in anderen Projekten verwenden.<br>
&middot; ohne schriftliche Zustimmung von web4.hm, die Software kostenlos
oder gegen Geb&uuml;hr verbreiten.<br>
<br>
<br>
Gew&auml;hrleistung<br>
F&Uuml;R DIE phpMySearch Softwareversionen BIETET WEB4.HM WEDER AUSDR&Uuml;CKLICH
NOCH STILLSCHWEIGEND IRGENDEINE GEW&Auml;HRLEISTUNG ODER NACHBESSERUNG AN.
SOFTWARE UND BEGLEITDOKUMENTATION DER phpMySearch Softwareversionen WERDEN
WIE BESEHEN ("AS IS") ZUR VERF&Uuml;GUNG GESTELLT.<br>
<br>
Wegen der inh&auml;renten Komplexit&auml;t von Programmen wie diesem gew&auml;hrleistet
web4.hm nicht, dass die Software fehlerfrei oder ohne Unterbrechung arbeitet.
Weiterhin garantiert web4.hm nicht, dass die Software mit irgendeiner Datenbank,
irgendeinem Netzwerk oder irgendeiner Anwendung funktioniert.<br>
<br>
Die Software wurde nicht entworfen und ist auch nicht bestimmt oder lizenziert
f&uuml;r die Verwendung in Gefahrenumgebungen, in denen eine ausfallsichere
Steuerung/Funktion erforderlich ist. Dies beinhaltet ohne Einschr&auml;nkung
Entwurf, Konstruktion, Wartung und Betrieb in den Bereichen nukleare Einrichtungen,
Flugzeugnavigations- und Kommunikationssysteme, Luftverkehrskontrolle sowie
lebenserhaltende Systeme und Waffensysteme. web4.hm lehnt ausdr&uuml;cklich
jede ausdr&uuml;ckliche oder stillschweigende Gew&auml;hrleistung f&uuml;r
die Eignung f&uuml;r solche Zwecke ab.<br>
<br>
Sie erkennen an, dass aufgrund der Komplexit&auml;t der Software die Verwendung
der Software zum unbeabsichtigten Verlust bzw. zur unbeabsichtigten Besch&auml;digung
von Daten f&uuml;hren k&ouml;nnte. Sie &uuml;bernehmen s&auml;mtliche Risiken
solcher Datenverluste oder Besch&auml;digung; die in diesem Vertrag vorgesehenen
Gew&auml;hrleistungen decken keinerlei Sch&auml;den und Verluste ab, die
durch Datenverluste oder -besch&auml;digung entstehen.<br>
<br>
<br>
Haftung<br>
IN KEINEM FALL HAFTET WEB4.HM F&Uuml;R IRGENDWELCHE INDIREKTEN, BEIL&Auml;UFIG
ENTSTANDENEN, BESONDEREN SCH&Auml;DEN UND VERLUSTE ODER ENTSCH&Auml;DIGUNGEN
MIT STRAFCHARAKTER ODER DECKUNGSSCH&Auml;DEN UND -VERLUSTE ODER F&Uuml;R
FOLGESCH&Auml;DEN UND -VERLUSTE, WOBEI DIES OHNE EINSCHR&Auml;NKUNG ENTGANGENE
GEWINNE, ENTGANGENE GESCH&Auml;FTE, GESCH&Auml;FTSUNTERBRECHUNG ODER DIE
UNF&Auml;HIGKEIT, GER&Auml;TE ZU VERWENDEN ODER AUF DATEN ZUZUGREIFEN, BEINHALTET,
UND ZWAR UNABH&Auml;NGIG DAVON, OB SOLCHE ENTSCH&Auml;DIGUNGSANSPR&Uuml;CHE
DURCH DEN BRUCH AUSDR&Uuml;CKLICHER ODER STILLSCHWEIGENDER GEW&Auml;HRLEISTUNGEN
BEGR&Uuml;NDET WERDEN, DURCH VERTRAGSBRUCH, DURCH FAHRL&Auml;SSIGKEIT, DURCH
GEF&Auml;HRDUNGSHAFTUNG, PRODUKTHAFTUNG ODER ANDERE RECHTSTHEORIEN. DAS GILT
SELBST DANN, WENN WEB4.HM VON DER M&Ouml;GLICHKEIT SOLCHER SCH&Auml;DEN UNTERRICHTET
WIRD. IN KEINEM FALL HAFTET WEB4.HM UNTER IRGENDEINER RECHTSTHEORIE IN EINER
H&Ouml;HE, DIE DIE H&Ouml;HE DER VON IHNEN TATS&Auml;CHLICH AN WEB4.HM ENTRICHTETEN
LIZENZGEB&Uuml;HR &Uuml;BERSTEIGT. DIE VORSTEHEND GENANNTEN BESCHR&Auml;NKUNGEN
GELTEN AUCH DANN, WENN DIE GEW&Auml;HRLEISTUNGEN IN DIESEM VERTRAG IHREN
WESENTLICHEN ZWECK VERFEHLEN. WEB4.HM HAFTET IN KEINSTER WEISE F&Uuml;R HARDWAREFEHLER
ODER ERH&Ouml;HTE TRAFFIKABRECHNUNGEN AUFGRUND DER BENUTZUNG DIESER SOFTWARE.
WEB4.HM IST IN KEINSTER WEISE VERANTWORTLICH F&Uuml;R DIE DURCHSUCHTEN SEITEN
ODER DEREN RESULTATE/FOLGEN. DIE BENUTZUNG DIESER SOFTWARE GESCHIEHT AUF
EIGENE GEFAHR UND OHNE JEGLICHER ANSPR&Uuml;CHE GEGEN&Uuml;BER WEB4.HM.<br>
<br>
<br>
Verfall der Lizenz<br>
Wenn Sie dieser Endbenutzerlizenz nicht zustimmen, so vernichten Sie alle
erhaltenen Kopien und Dokumente dieser Software innerhalb der n&auml;chsten
48 Stunden.<br>
web4.hm beh&auml;lt sich das Recht vor Endlizenznehmern die Benutzung, ohne
Angaben von Gr&uuml;nden, zu verbieten.<br>
<br>
<br>
Weitere M&ouml;glichkeiten<br>
Sie haben die M&ouml;glichkeit das Copyright in der HTML Ausgabe zu entfernen,
wenn Sie eine A-Lizenz erwerben. Diese kostet einmalig EURO&nbsp; 499,-.
Das gibt Ihnen aber keine Berechtigung, die Copyrighthinweise im Programmcode
zu &auml;ndern, sondern nur in der HTML Ausgabe der Templates. <br>
<br>
<br>
Vertragsstrafen<br>
Falls Sie gegen einer der Punkte unter den Benutzungsbedingungen versto&szlig;en
oder die Software mit Versto&szlig; dieser Endbenutzerlizenz betreiben oder
weiterver&auml;u&szlig;ern/anbieten, so wird eine Vertragsstrafe von EURO
2000,- Schadensersatz bei einem Erstvergehen festgesetzt. Anwendbar ist ausschlie&szlig;lich
deutsches Recht. Der Sitz von web4.hm ist auch gleichzeitig Gerichtsstand.<br>
<br>
<br>
Hersteller<br>
Webagentur web4.hm<br>
Pyrmonter Strasse 42<br>
D-31789<br>
Hameln<br>
Germany.<br>
Tel: +49-5151-609970-0<br>
Fax: +49-5151-609970-1<br>
http://www.web4.hm<br>
phpMySearch@web4.hm<br>
<br>
</body>
</html>

	<br><form name="FormName" action="install.php" method="POST">
			<p><input type="radio" value="3" name="Step">Ich habe die Lizens gelesen und stimme dieser zu.<br>
				<input type="radio" value="no" name="Step" checked>Ich stimme dieser Lizens nicht zu.</p>
			<div align="left">
				<p><input type="submit" name="submitButtonName" value="Next"></p>
			</div>
		</form>
	</body>

</html>

AUSGABE;

exit();

}




/**********************************************************************
	3rd site
**********************************************************************/

//check for system requirements
if ($HTTP_POST_VARS["Step"]=="3"){

	//check phpversion
	if (phpversion() < "4.0.2"){
		$InstallationsError = True;
		$Error .= "You system must have PHP 4.0.2 minimum! -> Please upgrade your PHP-version.<br>";
	}

	//check curl
	if (extension_loaded ("curl") != "1"){
		$InstallationsError = True;
		$Error .= "On your system must have Curl compiled in PHP! -> Please check www.php.net how you can do this.<br>";
	}

	//check call time
	if (ini_get ("allow_call_time_pass_reference") != True){
		$InstallationsError = True;
		$Error .= "Set in your php.ini <i>allow_call_time_pass_reference</i> to <i>On</i>.<br>";
	}

	//check for safe mode
	if (ini_get ("safe_mode") != False){
		$InstallationsError = True;
		$Error .= "Disable in your php.ini the <i>safe_mode</i>. -> Please check www.php.net how you can do this.<br>";				
	}
	
	//Add to error additional sentences
	if ($InstallationsError)
	{
		$Error .= "<br>
		If you are not able to do this yourself, ask your Internet Service Provider or your
		systemadministrator to change this.<br><br>
		<b>Installation aborted!</b><br>";
		
		//print error and abort installation
		echo $Error;
		exit();
		
	}

	//check if all files and directories are readable
	FileIsReadable($Path."search.php");
	FileIsReadable($Path."admin.php");
	FileIsReadable($Path."spider.php");
	FileIsReadable($Path."Src/ADTools.inc.php");
	FileIsReadable($Path."Src/class.AdminConfig.inc.php");
	FileIsReadable($Path."Src/class.Config.inc.php");
	FileIsReadable($Path."Src/class.Const.inc.php");
	FileIsReadable($Path."Src/class.ExpressionPrepocessor.inc.php");
	FileIsReadable($Path."Src/class.FastTemplate.php");
	FileIsReadable($Path."Src/class.Log.inc.php");
	FileIsReadable($Path."Src/class.RevPolNotation.inc.php");
	FileIsReadable($Path."Src/class.SearchEngine.inc.php");
	FileIsReadable($Path."Src/class.SearchVisualizer.inc.php");
	FileIsReadable($Path."Src/class.Session.inc.php");
	FileIsReadable($Path."Src/class.SessionManager.inc.php");
	FileIsReadable($Path."Src/class.SpiderEngine.inc.php");
	FileIsReadable($Path."Src/class.SpiderState.inc.php");
	FileIsReadable($Path."Src/class.Stats.inc.php");
	FileIsReadable($Path."Src/language.inc.php");
	FileIsReadable($Path."Src/limiter.inc.php");
	DirIsReadable($Path."log");
	DirIsReadable($Path."docs");
	DirIsReadable($Path."templates/standard");

	//send page to browser to put in all mysql-settings
	echo <<<AUSGABE
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<form name="FormName" action="install.php" method="POST">
			<div align="center">
				
    <p> 
      <input type="hidden" value="4" name="Step">
      <b><font color="red">$Error</font></b><br>
    </p>
    <h1>MySQL-Setup</h1>
    <p>Please insert now your MySQL-settings.<br>
    </p>
    <p>The MySQL-Database must be existing.</p>
    <p>All tables for phpMySearch will be created automaticly.</p>
    <table border="0" cellpadding="0" cellspacing="2">
					<tr>
						<td>MySQL-Host:</td>
						<td><input type="text" name="DBHost" size="24"></td>
					</tr>
					<tr>
						<td>MySQL-Database:</td>
						<td><input type="text" name="DBName" size="24"></td>
					</tr>
					<tr>
						<td>MySQL-User:</td>
						<td><input type="text" name="DBUser" size="24"></td>
					</tr>
					<tr>
						<td>MySQL-Passwort:</td>
						<td><input type="text" name="DBPassword" size="24"></td>
					</tr>
					<tr>
						<td colspan="2">
							<div align="center">
								<input type="submit" name="" value="Next"></div>
						</td>
					</tr>
				</table>
			</div>
		</form>
	</body>

</html>
AUSGABE;

exit();

}



/**********************************************************************
	4th site
**********************************************************************/

// check mysql settings
if ($HTTP_POST_VARS["Step"]=="4"){
	
	//move global vars to local
	$DBHost		= $HTTP_POST_VARS["DBHost"];
	$DBUser		= $HTTP_POST_VARS["DBUser"];
	$DBPassword	= $HTTP_POST_VARS["DBPassword"];
	$DBName		= $HTTP_POST_VARS["DBName"];

	//check given user mysql settings
        @mysql_connect($DBHost,$DBUser,$DBPassword) or die ("<br>Your MySQL-datas are incorrect.<br>MySQL said: <i>".mysql_error()."</i><br><br>Please go back with your webbrowser and check your datas.<br><br>");
	if (	!mysql_select_db($DBName) OR
		$DBHost =="" OR
		$DBUser =="" OR
		$DBName ==""
		)
	{
		
		//failure output
		$InstallationsError = True;
		$Error .= "<br>Your MySQL-datas are incorrect.<br>
	        Please go back with your webbrowser and check your datas.<br><br>";
	        
	        $a = mysql_error();
	        if ( $a !="")
	        {
	        	$Error .= "MySQL said: <i>".mysql_error()."</i>";
		}
	        echo $Error;
	        exit();
	}

	//check mysqlversion
	$result = mysql_query ("SELECT VERSION() AS VERSION");
	$row = mysql_fetch_row($result);
	if ($row[0] < "3.23")
	{
		//wrong mysqlversion 
		$InstallationsError = True;
		$Error .= "Please upgrade your <i>MySQL-Version</i> for phpMySearch you must have MySQL 3.23.x or higher.<br>";	
		echo $Error;
		exit();	
	}
	else
	{

		$result = mysql_query ("DROP TABLE IF EXISTS phpMySearch_Pages");
		$result = mysql_query ("DROP TABLE IF EXISTS phpMySearch_Sessions");
		$result = mysql_query ("DROP TABLE IF EXISTS phpMySearch_SessionsVal");
		$result = mysql_query ("DROP TABLE IF EXISTS phpMySearch_settings");
		$result = mysql_query ("DROP TABLE IF EXISTS phpMySearch_spider");
		$result = mysql_query ("DROP TABLE IF EXISTS phpMySearch_stats");
		$result = mysql_query ("DROP TABLE IF EXISTS phpMySearch_struct");

		//prepare DataBaseSettings
		$Text = <<<AUSGABE
<?php

\$DBHost     = "$DBHost";		//MySQL-Server
\$DBName     = "$DBName";		//MySQL-Database
\$DBUser     = "$DBUser";		//MySQL-Username
\$DBPassword = "$DBPassword";		//MySQL-Password


?><HTML><BODY bgcolor="#ffffff">
AUSGABE;

		//create log- and tmp-files
		CreateNewEmptyFile($Path."log/spider.log");
		CreateNewEmptyFile($Path."log/search.log");
		CreateNewEmptyFile($Path."log/admin.log");
		CreateNewEmptyFile($Path."log/_header.txt");
		CreateNewEmptyFile($Path."log/php_homepage.txt");

		//create file for DataBaseSettings
		CreateNewEmptyFile($DataBaseSettings);

		//write DataBaseSettings into file
		$fp = fopen($DataBaseSettings,"w+");
		$fw = fwrite($fp,$Text);
		fclose ($fp);

		//outputs the last page if all is done successfully
		echo <<<AUSGABE
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<div align="left">
			<p><b><font size="4">Congratulations!</font></b></p>
		</div>
		<p></p>
		<p>phpMySearch is successfully installed.</p>
		<p>Please read carefully now for all options the manual which is available here: <a href="manual/index.html" target="_blank">manual</a></p>
		<p></p>
		<p>In the manual you will inform about your standard login datas where you can login</p>
		<p>into your phpMySearch <a href="admin.php" target="_blank">admintool</a>.</p>
	</body>

</html>
AUSGABE;
	exit();
	}

}

/**********************************************************************
	end of installation
**********************************************************************/

?>